<template>
   <div class="p-2 w-100">
        <v-card class="w-100">
                  <v-toolbar color="white custom-top" flat>

          <v-toolbar-title class="grey--text text--darken-4">
              <span >
                 Nouvelle demande
              </span>
          </v-toolbar-title>

          <v-spacer></v-spacer>
          <v-menu bottom left>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                color="grey"
                class="text-center"
                icon
                v-bind="attrs"
                v-on="on"
              >
                <v-icon left>mdi-dots-vertical</v-icon>
              </v-btn>
            </template>
          </v-menu>

        </v-toolbar>
        <v-row class="pl-1 pr-1">

        </v-row>
        <v-divider class="mt-0 mb-0"></v-divider>
         <v-card-text class="p-0">
            <ValidationObserver ref="observer" v-slot="{ validate, reset }">
              <form>
           <v-stepper v-model="e6" vertical>
               <span v-for="(step,n) in steps" :key="n" >
                  <v-stepper-step :key="n"  :complete="stepComplete(n+1) && step.valid" :step="n+1" :color="stepStatus(1)">
                    {{step.name}}
                    <small>{{step.subtitle}}</small>
                  </v-stepper-step>
                    <v-stepper-content  v-if="n==0"  step="1">
                      <div color="" class="mb-12">
                          <v-row>
                                  <v-col cols="12" :sm="form.patient_known ? 6 : 12" :md="form.patient_known ? 6 : 12">
                                  <v-switch class="pl-2 pr-2"  inset
                                    v-model="form.patient_known"
                                    label="Le patient est connu de bioclin"
                                  ></v-switch>
                                  </v-col>
                                  <v-col v-if="form.patient_known" cols="12" sm="6" md="6">
                                      <v-autocomplete outlined
                                        v-model="form.patient.id"
                                        :items="_patients"
                                        item-value="id"
                                        @change="patientRecovery(form.patient.id)"
                                        item-text="fullName"
                                        menu-props="auto"
                                        label="Rechercher le patient"
                                        hint="Entrez le nom du patient que vous souhaitez rechercher">
                                      </v-autocomplete>
                                  </v-col>
                                  <v-col cols="12" sm="6" md="6">
                                        <ValidationProvider v-slot="{ errors }" name="lastname" rules="required">
                                                <v-text-field :disabled="form.patient_known" outlined v-model="form.patient.lastname" label="Nom du patient"></v-text-field>
                                        </ValidationProvider>
                                  </v-col>
                                  <v-col cols="12" sm="6" md="6">
                                    <v-text-field :disabled="form.patient_known" outlined v-model="form.patient.firstname" label="Prénom du patient"></v-text-field>
                                  </v-col>
                                  <v-col cols="12" sm="6" md="6">
                                    <v-text-field :disabled="form.patient_known" outlined v-model="form.patient.birthdate" type="date" label="Date de naissance"></v-text-field>
                                  </v-col>
                                  <v-col cols="12" sm="6" md="6">
                                    <v-text-field :disabled="form.patient_known" outlined v-model="form.patient.phone_number" label="Numero de téléphone"></v-text-field>
                                  </v-col>
                                  <v-col cols="12" sm="6" md="6">
                                      <v-select :disabled="form.patient_known" outlined v-model="form.patient.gender" :items="['M','F']" menu-props="auto" label="Genre du patient" hide-details></v-select>
                                  </v-col>
                          </v-row>
                      </div>
                      <v-btn color="primary" @click="e6 = 2">Continuer</v-btn>
                    </v-stepper-content>
                    <v-stepper-content  v-if="n==1" step="2">
                              <div color="" class="mb-12">
                                <v-row>
                                  <v-col cols="12" sm="6" md="6">
                                    <v-text-field  outlined v-model="form.name_physician" label="Nom complet du medécin"></v-text-field>
                                  </v-col>
                                  <v-col cols="12" sm="6" md="6">
                                      <v-autocomplete outlined
                                        v-model="form.qualification_id"
                                        :items="qualifications"
                                        menu-props="auto"
                                        item-value="id"
                                        item-text="label"
                                        label="Spécialité du medécin"
                                        :filter="customFilter"
                                        hide-details>
                                        </v-autocomplete>
                                  </v-col>
                                  <v-col cols="12" sm="6" md="6">
                                    <v-text-field outlined v-model="form.order_number_physician" type="text" label="Numero d'ordre"></v-text-field>
                                  </v-col>
                                  <v-col cols="12" sm="6" md="6">
                                    <v-text-field outlined v-model="form.hospital" type="text" label="Nom de l'hopital"></v-text-field>
                                  </v-col>
                                </v-row>
                              </div>
                      <v-btn color="primary" @click="e6 = 3">Continuer</v-btn>
                      <v-btn text @click="e6 = 1">Retour</v-btn>
                    </v-stepper-content>
                    <v-stepper-content  v-if="n==2" step="3">
                                <v-row>
                                  <v-col cols="12" :sm="form.patient_is_insured ? 4 : 4" :md="form.patient_is_insured ? 4 : 4">
                                  <v-switch class="pl-2 pr-2"  inset v-model="form.patient_is_insured" label="Le patient a une assurance ?">

                                  </v-switch>
                                  </v-col>
                                  <v-col v-if="form.patient_is_insured" cols="12" sm="4" md="4">
                                  <v-select
                                      outlined
                                      menu-props="auto"
                                      label="Choix de l'assurance"
                                      hint="La liste des assurances supportées par BIOCLIN"
                                      v-model="selectedInsuranceId"
                                      :items="availableInsurances"
                                      item-value="id"
                                      item-text="name_upper">
                                  </v-select>
                                  </v-col>
                                  <v-col v-if="form.patient_is_insured" cols="12" sm="4" md="4">
                                            <div class="my-2">
                                              <v-btn :disabled="!availableInsurances.length>0" @click="addInsurance" block color="primary">Ajouter l'assurance</v-btn>
                                            </div>
                                  </v-col>
                                  </v-row>
                                  <v-row v-for="(insurance,key) in form.insurances" :key="key">
                                    <v-banner single-line class="w-100" >
                                          {{insurance.insurance_name}}
                                      <template v-slot:actions>
                                          <v-btn  fab dark small text color="accent-4" @click="removeInsurance(key)">
                                            <v-icon  color="grey darken-2">mdi-close</v-icon>
                                          </v-btn>
                                      </template>
                                    </v-banner>
                                    <v-col cols="12" sm="6" md="6">
                                      <v-text-field v-if="form.patient_is_insured" outlined v-model="form.insurances[key].insurance_number" label="Le n° de l'assurance"></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6" md="6">
                                      <div v-if="form.patient_is_insured">
                                          <p class="mb-0">Statut de l'assuré</p>
                                          <v-radio-group class="mt-0" v-model="form.insurances[key].main_insured" row>
                                            <v-radio label="Assuré principal" :value="true"></v-radio>
                                            <v-radio label="Ayant droit" :value="false"></v-radio>
                                          </v-radio-group>
                                      </div>
                                    </v-col>
                                    <v-col cols="12" sm="6" md="6" v-if="!form.insurances[key].main_insured">
                                      <v-text-field v-if="form.patient_is_insured"  outlined v-model="form.insurances[key].main_insured_name" label="Nom & Prénom de l'assuré principal"></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6" md="6" v-if="!form.insurances[key].main_insured">
                                      <v-text-field v-if="form.patient_is_insured"  outlined v-model="form.insurances[key].main_insured_number" type="text" label="N° Assuré principal"></v-text-field>
                                    </v-col>
                                </v-row>
                      <v-btn color="primary" @click="e6 = 4">Continuer</v-btn>
                      <v-btn text @click="e6 = 2">Retour</v-btn>
                    </v-stepper-content>
                    <v-stepper-content  v-if="n==3" step="4">
                      <v-row>
                                  <v-col cols="12">
                                  <v-switch v-if="form.patient_is_insured" class="pl-2 pr-2"  inset v-model="form.apply_default_insurance" label="Appliquer l'assurance par défaut">

                                  </v-switch>
                                  </v-col>
                                    <v-autocomplete
                                      class="pr-4 pl-4"
                                      v-model="selectedExams"
                                      :items="exams"
                                      :search-input.sync="searchInput"
                                      @input="onSelectedExam"
                                      no-data-text="Aucune donnée disponible"
                                      :hide-selected="true"
                                      chips
                                      color="blue-grey lighten-2"
                                      label="Choisir les examens"
                                      item-text="name"
                                      item-value="id"
                                      multiple>
                                        <template v-slot:selection="data">
                                          <v-chip
                                            v-bind="data.attrs"
                                            :input-value="data.selected"
                                            close
                                            @click="data.select"
                                            @click:close="removeExam(data.item)">
                                            {{ data.item.name }}
                                          </v-chip>
                                        </template>
                                        <template v-slot:item="data">
                                          <template v-if="typeof data.item !== 'object'">
                                            <v-list-item-content v-text="data.item"></v-list-item-content>
                                          </template>
                                          <template v-else>
                                            <v-list-item-content>
                                              <v-list-item-title v-html="data.item.name"></v-list-item-title>
                                              <v-list-item-subtitle v-html=" data.item.examtype ? 'Examen' +data.item.examtype.label : 'Type non précisé'"></v-list-item-subtitle>
                                            </v-list-item-content>
                                          </template>
                                        </template>
                                  </v-autocomplete>
                          </v-row>
                          <v-row v-if="form.exams.length>0">
                                    <v-simple-table class="w-100">
                                      <template v-slot:default>
                                        <thead>
                                          <tr>
                                            <th class="text-left">Nom de l'examen</th>
                                            <th class="text-left">Payement sans assurances</th>
                                            <th class="text-left">Assurance</th>
                                            <th class="text-left">Montant</th>
                                            <th class="text-left">Action</th>
                                          </tr>
                                        </thead>
                                        <tbody>
                                          <tr v-for="item in form.exams" :key="item.id">
                                            <td>{{ item.name }}</td>
                                            <td>
                                              <v-col cols="12">
                                                <v-switch :disabled="!getMixedInsurance(item).length>0"  @click="updateSelectedExam(item)" class="pl-2 pr-2"  inset v-model="item.payement_without_insurance" :label="item.payement_without_insurance?'OUI' : 'NON'">

                                                </v-switch>
                                              </v-col>
                                            </td>
                                            <td>
                                                <v-select
                                                        outlined
                                                        @change="onSelectedInsuranceForExam($event,item)"
                                                        menu-props="auto"
                                                        v-if="!item.payement_without_insurance"
                                                        :label="item.payement_without_insurance ? 'Option désactivée':'Choix de l\'assurance'"
                                                        hint=""
                                                        :items="getMixedInsurance(item)"
                                                        item-value="id"
                                                        item-text="name_upper">
                                                </v-select>
                                                <span v-else>
                                                  Assurance désactivée
                                                </span>
                                            </td>
                                            <td>{{ item.payement_without_insurance ? item.base_price : item.current_price }} F cfa</td>
                                            <td>
                                                <v-btn @click="removeExam(item)"  fab dark small text color="accent-4" >
                                                    <v-icon  color="grey darken-2">mdi-close</v-icon>
                                                </v-btn>
                                            </td>
                                          </tr>
                                        </tbody>
                                      </template>
                                    </v-simple-table>
                            </v-row>
                      <v-btn color="primary" @click="onSubmit">Continuer</v-btn>
                      <v-btn text @click="e6 = 3">Retour</v-btn>
                    </v-stepper-content>
               </span>
  </v-stepper>
  </form>
  </ValidationObserver>
         </v-card-text>
    </v-card>
    <v-card>
      <v-row>

      </v-row>
    </v-card>

   </div>
</template>

<script>

  import { mapGetters } from 'vuex'
import {
  ValidationObserver,
  ValidationProvider,
  withValidation
} from "vee-validate";
  export default {
    data: () => ({
      //Steps
        steps:
        [
            {name: "Patient", subtitle:"Identité du patient", rules: [v => !!v || "Required."], valid: true},
            {name: "Medécin prescripteur",subtitle:"Identité du medécin", rules: [v=> !!v || "Required."], valid: true},
            {name: "Assurances", subtitle:"",rules: [v => (v && v.length >= 4) || "Enter at least 4 characters."], valid: true},
            {name: "Examen",subtitle:"",},
        ],
      //AUTOCOMPLETE EXAMS
      isUpdatingExam: false,
      selectedExams:[],
      searchInput:"",
      removedExam:false,
      //
      e6: 1,

      selectedInsuranceId:"",
      selectedInsurance:"",

      row:null,
      form : new Form({
              old_patient:false,
              patient_known: false,
              apply_default_insurance:false,
              patient: {
                id :"",
                lastname : '',
                firstname : "",
                phone_number : "",
                birthdate : "",
                gender : "",
              },
              //Medecin
              name_physician : "",
              firstname_physician : "",
              qualification_id : "",
              order_number_physician : "",
              hospital : "",

              //Assurance
              insurances:[],
              exams:[],
              patient_is_insured : false,

      }),
      assurances: ['CNAMGS','ASCOMA'],
      type_demandes: ['Bactoriologique'],
      demandes : [],
      dataFilters: {},
      dialog: false,
      singleSelect: false,
      selected: [],
      expanded: [],
      singleExpand: false,
      gridConfig: {
        records: [],
        loading: true,
        options: {
          itemsPerPageOptions: [10, 25, 50, 100],
          totalPages: 0,
          itemsPerPage: 10,
          page: 1,
          descending: false,
        }
      },
      headers: [
        {
          text: 'N°',
          align: 'left',
          sortable: true,
          value: 'file_number',
        },
        { text: 'Identité du patient', value: 'patient' },
        { text: 'Assurance', value: '' },
        { text: 'Statut', value: 'status',align:"center" },
         { text: 'Date de création', value: 'created_at' },
        { text: 'Actions', value: 'actions', sortable: false },
      ],
      desserts: [],
      editedIndex: -1,
      editedItem: {
        name: '',
        calories: 0,
        assurance: 0,
        TM: 0,
        GAP: 0,
      },
      defaultItem: {
        name: '',
        calories: 0,
        assurance: 0,
        TM: 0,
        GAP: 0,
      },
    }),

    computed: {
       ...mapGetters({initialized:'demands/initialized',qualifications:'params/_qualifications',_patients:'params/_patients', patient:'patients/patient', insurances:'params/_insurances', moreExists:'demands/moreExists',next_page_url:"demands/next_page_url",total:"demands/total"
          ,exams:'params/_exams'  ,current_page:"demands/current_page",items:"demands/_items",loading:"demands/loading",loaded:"demands/loaded"}),
      //Titre du modal
      formTitle () {
        return this.editedIndex === -1 ? "Nouvelle Demande" : "Modification de la demande"
      },
      
      //Indique si l'assurance est la cnamgs
      is_cnamgs()
      {
        return this.selectedInsuranceId == "CNAMGS" ? true : false
      },
      //Indique si l'assurance est cgr
      is_cgr()
      {
        return this.selectedInsuranceId == "CGR" ? true : false
      },
      //Indique si l'assurance est ascoma
      is_ascoma()
      {
        return this.selectedInsuranceId == "ASCOMA" ? true : false
      },
      //Indique si l'assurance est grass-savoye
      is_grass_savoye()
      {
        return this.selectedInsuranceId == "GRASS SAVOYE" ? true : false
      },
      //Indique si l'assurance est grass-savoye
      is_qualification_other()
      {
        if(this.form.qualification_id == null)
        {
           return false;
        }
        else
        {
          var qualification = this.qualifications.find( e => {
              return e.id == this.form.qualification_id
          })
          return !qualification ? false : (qualification.label == "autre");
        }
        return this.selectedInsuranceId == "GRASS SAVOYE" ? true : false
      },
      //Retourne les assurances disponibles
      availableInsurances()
      {
          // Make hashtable of ids in B
          var bIds = {}
          this.form.insurances.forEach(function(obj){
              bIds[obj.insurance_id] = obj;
          });

          // Return all elements in A, unless in B
          return this.insurances.filter(function(obj){
              return !(obj.id in bIds);
          });
      },
    },
    components: {
      ValidationProvider,
      ValidationObserver
    },
    watch: {
      dialog (val) {
        val || this.close()
      },
      isUpdatingExam (val)
      {
        if (val) {
          setTimeout(() => (this.isUpdatingExam = false), 3000)
        }
      },
      'selectedInsuranceId': function (n)
      {
         if(n!="" && n!=undefined)
         this.selectedInsurance = this.insurances.find( e => { return e.id == n })

      },
      'selectedExams': function (n,o)
      {
         if(this.removedExam==false)
         {
            this.searchInput = ""
            if(n.length>o.length)
            {
              this.searchInput = ""
              //on ajoute le contenu
              var exam = this.exams.find( e => { return e.id == n[n.length-1]})

                this.form.exams.push
                ({
                    id:exam.id,
                    name:exam.name,
                    insurance_id : "",
                    payement_without_insurance:false,
                    base_price : exam.base_price,
                    current_price : 0,
                })
            }
            else
            {
              //On retire
              var exam = this.exams.find( e => { return e.id == o[o.length-1]})
              console.log('on retire')
              this.form.exams = this.form.exams.filter( e => {
                return exam.id != e. id
              })
              if(n.length==0)
              {
                this.form.exams = []
              }

            }
         }
         else
         {
            this.removedExam = false
         }
      },
       'form.patient_is_insured': function (n)
      {
         if(!n)
         {
            this.form.insurances = []
            this.initSelectInsurance()
         }

      },
    },

    created () {
      // this.initialize()
    //  window.event.$emit("isLoading",true)
      this.$store.dispatch('demands/init')
      this.$store.dispatch('demands/getDemands')
      console.log('init')
    },

    methods: {
      //Reinitialisation
      initForm()
      {
         this.e6=1
         this.form.patient.id=this.form.patient.lastname=this.form.patient.firstname=""
         this.form.patient.birthdate=this.form.patient.phone_number=this.form.patient.gender=""

         this.form.exams=this.form.insurances=[]

         this.form.hospital=this.form.qualification_id=this.form.order_number_physician=this.form.name_physician =""
         this.form.patient_know=this.form.patient.is_insured=this.form.apply_default_insurance = false
      },
      //onSubmit
      onSubmit()
      {
        this.$store.dispatch('demands/addDemand',this.form.data())
                .then((response) =>
                {
                   //on informe du succes de la procedure
                   flash('Nouvelle demande d\examen créée')
                   //On remonte au sommet de la fenetre
                   window.scrollTo(0,0)
                   //on réinitialise le formulaire
                   this.initForm()
                },
                (error) => {

                });
            },
              stepStatus(step) {
            return this.e6 > step ? 'green' : 'blue'
        },

       patientRecovery(patient_id){
        // this.$store.dispatch('patients/getPatient',patient_id)
        // this.form.patient.firstname = 'patient.firstname'
        // this.form.patient.lastname = 'patient.lastname'
        // this.form.patient.birthdate = 'patient.birthday'
        // this.form.patient.phone_number = 'patient.phone'
        // this.form.patient.gender = 'patient.gender'
      },

      getMixedInsurance(item)
      {
           //on recupere l'examen
           var exam = this.exams.find( e => {  return e.id == item.id});
           //puis les assurances qui le couvrent
           var insurance =_.map(exam.insurances,'id')
           //ainsi que les assurances du patient actuel
           var p_insurances = _.map(this.form.insurances,'insurance_id')

           var acceptedKeys = _.intersection(insurance,p_insurances)
           var accepted = this.insurances.filter(e =>{
              return acceptedKeys.indexOf(e.id) > -1;
            })

            if(accepted.length<=0 && item.payement_without_insurance == false)
            item.payement_without_insurance = true

            return accepted;
      },
      onSelectedInsuranceForExam(e,item)
      {
         //on recupere l'assurance concernée
         var exam = this.exams.find( e => {  return e.id == item.id});
         var insurance = exam.insurances.find( ex => { return ex.id == e});
         item.current_price = insurance.pivot.price
         item.insurance_id = insurance.id
      },
      //
      updateSelectedExam(item)
      {
          item.current_price = item.payement_without_insurance ? item.base_price : "-"
      },
      onSelectedExam(item)
      {
                //On recupere l'exam
        // if(item.length==0 || item==undefined)
        // {
        //   this.selectedExams = [];
        //   this.form.exams = [] ;
        // }
        // else
        // {
        //     var exam = this.exams.find( e => { return e.id == item[item.length-1]})
        //     if(item.length > this.form.exams )
        //     {
        //       this.form.exams.push
        //       ({
        //           id:exam.id,
        //           name:exam.name,
        //           insurance_id : "",
        //           base_price : exam.base_price,
        //       })
        //     }
        //     else
        //   {
        //     this.removeExam(exam)
        //   }
        // }


      },
      removeExam(item)
      {
        //console.log(item)
        this.removedExam = true
        const index = this.selectedExams.indexOf(item.id)
        if (index >= 0) this.selectedExams.splice(index, 1)
        this.form.exams = this.form.exams.filter( e => {
         return item.id != e. id
        })
      },
      //Ajoute une assurance
      addInsurance()
      {
          if(this.selectedInsurance!="" && this.selectedInsurance!=undefined && this.selectedInsurance!=null )
          {
              this.form.insurances.push
              ({
                  insurance_number:"",
                  insurance_name:this.selectedInsurance.name_upper,
                  insurance_acronym:this.selectedInsurance.acronym,
                  insurance_id : this.selectedInsurance.id,
                  main_insured :"",
                  main_insured : true,
                  beneficiary: false,
                  main_insured_name:"",
                  main_insured_number:""
              })
            this.initSelectInsurance()
          }
          else
          {
            flash("Vous devez d'abord choisir une assurance")
          }

      },

      //Initialise l'assurance sélectionnée
      initSelectInsurance()
      {
        this.selectedInsurance =""
        this.selectedInsuranceId = ""
      },

      getColor (status) {
        if (status=="Enregistré") return 'orange'
        else if (status=="En cours") return 'blue'
        else if (status=="Annulé") return 'silver'
        else if (status=="Traité") return 'green'
        else return 'silver'
      },

      addExamen () {

      },

      editItem (item) {
        this.editedIndex = this.items.indexOf(item)
        this.editedItem = Object.assign({}, item)
        this.dialog = true
      },
      seeDemand (item) {
          //alert('Voir demande')
          var id = item.id
          this.$router.push({ name: 'demand-detail', params: { id } })
      },
      deleteItem (item) {
        const index = this.items.indexOf(item)
        confirm('Etes-vous de vouloir supprimer cet element?') && this.items.splice(index, 1)
      },

      close () {
        this.dialog = false
        this.$nextTick(() => {
          this.editedItem = Object.assign({}, this.defaultItem)
          this.editedIndex = -1
        })
      },
      customFilter (item, queryText, itemText) {
        const textOne = item.label.toLowerCase()
        const searchText = queryText.toLowerCase()

        return textOne.indexOf(searchText) > -1
      },
      save () {
        if (this.editedIndex > -1)
        {
          Object.assign(this.items[this.editedIndex], this.editedItem)
        }
        else
        {
          this.items.push(this.editedItem)
        }
        this.close()
      },

    disableAddInsuranceButton()
      {
        if(this.editedItem)
        return this.editedItem.demandes.length >= 3 ;
        else
        return false
      },

        //Retire une assurance de la liste
       removeInsurance (key)
       {
         this.form.insurances.splice(key,1)
       },
      stepComplete(step)
      {
        return this.curr > step
      },
      validate(n)
      {
            this.steps[n].valid = false
            let v = this.$refs.stepForm[n].validate()
            if (v) {
                this.steps[n].valid = true
                // continue to next
                this.curr = n+2
            }
        },
    },
  }
</script>
<style lang="scss" scoped>
.custom-top .v-toolbar__title {
    font-size: 1.25rem;
    line-height: 1;
}
</style>
